## spglib 2.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25...3.29)

#[=============================================================================[
#                           Basic project definition                           #
]=============================================================================]

include(cmake/DynamicVersion.cmake)
# Get dynamic version and save it to PROJECT_VERSION
dynamic_version(
        PROJECT_PREFIX Spglib_
        FALLBACK_VERSION 0.0.0
)
list(APPEND CMAKE_MESSAGE_CONTEXT Spglib)
project(Spglib
        VERSION ${PROJECT_VERSION}
        LANGUAGES C)
set(Spglib_VERSION_FULL ${PROJECT_VERSION_FULL})
set(Spglib_COMMIT ${GIT_COMMIT})

set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif ()

#[=============================================================================[
#                                   Options                                   #
]=============================================================================]

# Boilerplate default values
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(_Spglib_default_debug ON)
else ()
    set(_Spglib_default_debug OFF)
endif ()

#
option(SPGLIB_WITH_Fortran "Spglib: Build Fortran interface" OFF)
option(SPGLIB_WITH_Python "Spglib: Build Python interface" OFF)
option(SPGLIB_USE_OMP "Spglib: Build with OpenMP support" OFF)
option(SPGLIB_WITH_TESTS "Spglib: Build unit tests" ${PROJECT_IS_TOP_LEVEL})
option(SPGLIB_SHARED_LIBS "Spglib: Build as a shared library" ${PROJECT_IS_TOP_LEVEL})
option(SPGLIB_INSTALL "Spglib: Install project" ${PROJECT_IS_TOP_LEVEL})
option(SPGLIB_WARNINGS "Spglib: Enable warning messages" ON)
option(SPGLIB_INFO "Spglib: Enable info messages" ON)
option(SPGLIB_DEBUG "Spglib: Build in debug mode" ${_Spglib_default_debug})
option(SPGLIB_COMPILATION_WARNING "Spglib: Enable compilation warnings" OFF)
mark_as_advanced(
        SPGLIB_DEBUG
        SPGLIB_WARNINGS
        SPGLIB_COMPILATION_WARNING
)

#[=============================================================================[
#                            Project configuration                            #
]=============================================================================]

# Include basic tools
include(cmake/PackageCompsHelper.cmake)
include(FetchContent)
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

# Define basic parameters
set(BUILD_SHARED_LIBS ${SPGLIB_SHARED_LIBS})
if (BUILD_SHARED_LIBS)
    set(Spglib_LIB_TYPE "shared")
else ()
    set(Spglib_LIB_TYPE "static")
endif ()

set(CMAKE_MACOSX_RPATH 1)
# Windows setup
if (WIN32)
    # Add appropriate debug flags
    set(CMAKE_MSVC_DEBUG_INFORMATION_FORMAT "$<$<CONFIG:Debug,RelWithDebInfo>:ProgramDatabase>")
endif ()

# Report configuration
message(STATUS "Spglib:: Build type: ${CMAKE_BUILD_TYPE}")
message(STATUS "Spglib:: Version ${PROJECT_VERSION_FULL}")

#[=============================================================================[
#                                Public targets                                #
]=============================================================================]

add_library(Spglib_symspg)
add_library(Spglib::symspg ALIAS Spglib_symspg)

#[=============================================================================[
#                              External packages                              #
]=============================================================================]

# Include third-party libraries
set(spglib_dependencies "")
if (SPGLIB_USE_OMP)
    find_package(OpenMP REQUIRED COMPONENTS C)
endif ()

#[=============================================================================[
#                               Main definition                               #
]=============================================================================]

# Main project
set_target_properties(Spglib_symspg PROPERTIES
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        EXPORT_NAME symspg
        OUTPUT_NAME symspg
)
# Main definitions inside src
add_subdirectory(include)
add_subdirectory(src)

# Bindings
if (NOT TARGET Spglib::fortran AND SPGLIB_WITH_Fortran)
    add_subdirectory(fortran)
endif ()
if (NOT TARGET Spglib::python AND SPGLIB_WITH_Python)
    add_subdirectory(python)
endif ()

# Testing
if (SPGLIB_WITH_TESTS)
    enable_testing()
    add_subdirectory(test)
endif ()

#[=============================================================================[
#                              Install or Export                              #
]=============================================================================]

# Installation

# Copy PackageCompsHelper to make it available for build import
configure_file(cmake/PackageCompsHelper.cmake PackageCompsHelper.cmake COPYONLY)
if (SPGLIB_INSTALL)
    # pkg-config files
    configure_file(cmake/spglib.pc.in spglib.pc @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/spglib.pc
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    )

    # cmake export files
    write_basic_package_version_file(
            ${CMAKE_CURRENT_BINARY_DIR}/SpglibConfigVersion.cmake
            VERSION ${PROJECT_VERSION}
            COMPATIBILITY SameMajorVersion)
    configure_package_config_file(
            cmake/SpglibConfig.cmake.in
            ${CMAKE_CURRENT_BINARY_DIR}/SpglibConfig.cmake
            INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Spglib)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/SpglibConfigVersion.cmake
            ${CMAKE_CURRENT_BINARY_DIR}/SpglibConfig.cmake
            cmake/PackageCompsHelper.cmake
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Spglib
    )
    export_components(LIB_TYPE ${Spglib_LIB_TYPE})
endif ()

# Make project available for FetchContent
if (NOT PROJECT_IS_TOP_LEVEL)
    # Set variables for FetchContent
    # All variables have to be consistent with SpglibConfig.cmake
    set(Spglib_Fortran ${SPGLIB_WITH_Fortran})
    set(Spglib_Python ${SPGLIB_WITH_Python})
    set(Spglib_OMP ${SPGLIB_USE_OMP})
    # Propagate variables
    return(PROPAGATE
            Spglib_VERSION
            Spglib_VERSION_MAJOR
            Spglib_VERSION_MINOR
            Spglib_VERSION_PATCH
            Spglib_VERSION_TWEAK
            Spglib_VERSION_FULL
            Spglib_COMMIT
            Spglib_Fortran
            Spglib_Python
            Spglib_OMP
            Spglib_LIB_TYPE
    )
endif ()

=== fortran/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25...3.29)

#[=============================================================================[
#                           Basic project definition                           #
]=============================================================================]

list(APPEND CMAKE_MESSAGE_CONTEXT Fortran)

if (NOT COMMAND dynamic_version)
    include(../cmake/DynamicVersion.cmake)
endif ()
# Get dynamic version and save it to PROJECT_VERSION
dynamic_version(
        PROJECT_PREFIX Spglib_Fortran_
        PROJECT_SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/..
        FALLBACK_VERSION 0.0.0
        OUTPUT_VERSION_FULL Spglib_Fortran_VERSION_FULL
        OUTPUT_COMMIT Spglib_Fortran_COMMIT
)

project(Spglib_Fortran
        VERSION ${PROJECT_VERSION}
        LANGUAGES Fortran
)

#[=============================================================================[
#                                   Options                                   #
]=============================================================================]

option(SPGLIB_INSTALL "Spglib: Install project" ${PROJECT_IS_TOP_LEVEL})
option(SPGLIB_SHARED_LIBS "Spglib: Build as a shared library" ${PROJECT_IS_TOP_LEVEL})
if (SPGLIB_INSTALL)
    # CMake does not properly support fortran module installation paths.
    # Adapting the standard from fortran-stdlib
    # https://gitlab.kitware.com/cmake/cmake/-/issues/19608
    # https://discourse.cmake.org/t/api-design-c-modules-source-listings-and-interface-properties/5389/14
    cmake_path(APPEND CMAKE_INSTALL_INCLUDEDIR ${PROJECT_NAME} "${CMAKE_Fortran_COMPILER_ID}-${CMAKE_Fortran_COMPILER_VERSION}"
            OUTPUT_VARIABLE _DEFAULT_CMAKE_INSTALL_MODULEDIR)
    set(CMAKE_INSTALL_MODULEDIR ${_DEFAULT_CMAKE_INSTALL_MODULEDIR}
            CACHE STRING
            "Fortran module installation path (Not a cmake native variable)"
    )
endif ()

#[=============================================================================[
#                            Project configuration                            #
]=============================================================================]

include(GNUInstallDirs)
include(../cmake/PackageCompsHelper.cmake)

# Define basic parameters
if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif ()
set(BUILD_SHARED_LIBS ${SPGLIB_SHARED_LIBS})
if (BUILD_SHARED_LIBS)
    set(Spglib_LIB_TYPE "shared")
else ()
    set(Spglib_LIB_TYPE "static")
endif ()

if (NOT CMAKE_Fortran_MODULE_DIRECTORY)
    set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/fortran_mods)
endif ()

#[=============================================================================[
#                                Public targets                                #
]=============================================================================]

add_library(Spglib_fortran)
add_library(Spglib::fortran ALIAS Spglib_fortran)

#[=============================================================================[
#                              External packages                              #
]=============================================================================]

# Get Spglib if it's run as stand-alone project
if (NOT TARGET Spglib::symspg)
    find_package(Spglib CONFIG)
    if (NOT Spglib_FOUND)
        message(STATUS "Using bundled spglib sources")
        add_subdirectory(${PROJECT_SOURCE_DIR}/.. _deps/spglib-build)
    endif ()
endif ()

#[=============================================================================[
#                               Main definition                               #
]=============================================================================]

# Define main target
set_target_properties(Spglib_fortran PROPERTIES
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        EXPORT_NAME fortran_mod
        OUTPUT_NAME spglib_f08
)

# This target is only used in the SpglibConfig.cmake
add_library(Spglib_fortran_include INTERFACE)
set_target_properties(Spglib_fortran_include PROPERTIES
        EXPORT_NAME fortran_include
)

# Configure Fortran wrapper
configure_file(spglib_version.f90.in spglib_version.f90)

target_sources(Spglib_fortran_include INTERFACE
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/spglib_f08.F90>"
)

# Concatenate the contents of the fortran file so it can be compiled from source
execute_process(COMMAND ${CMAKE_COMMAND} -E cat
        ${CMAKE_CURRENT_BINARY_DIR}/spglib_version.f90
        ${CMAKE_CURRENT_SOURCE_DIR}/spglib_f08.F90
        OUTPUT_VARIABLE spglib_f08_concat
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/spglib_f08.F90 ${spglib_f08_concat})

# Use the separate files for the project itself so that they are properly re-built
target_sources(Spglib_fortran PRIVATE
        spglib_f08.F90
        ${CMAKE_CURRENT_BINARY_DIR}/spglib_version.f90
)

set_target_properties(Spglib_fortran_include PROPERTIES
        PUBLIC_HEADER ${CMAKE_CURRENT_BINARY_DIR}/spglib_f08.F90
)
target_include_directories(Spglib_fortran PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_Fortran_MODULE_DIRECTORY}>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_MODULEDIR}>"
)
target_link_libraries(Spglib_fortran PUBLIC Spglib::symspg)
target_link_libraries(Spglib_fortran_include INTERFACE Spglib::symspg)

#[=============================================================================[
#                              Install or Export                              #
]=============================================================================]

# Copy PackageCompsHelper to make it available for build import
if (Spglib_BINARY_DIR)
    configure_file(try_compile.f90 ${Spglib_BINARY_DIR}/try_compile.f90 COPYONLY)
endif ()

# Install
if (SPGLIB_INSTALL)
    cmake_path(IS_ABSOLUTE CMAKE_INSTALL_MODULEDIR _is_absolute)
    if (_is_absolute)
        set(CMAKE_INSTALL_FULL_MODULEDIR ${CMAKE_INSTALL_MODULEDIR})
    else ()
        cmake_path(APPEND CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_MODULEDIR}
                OUTPUT_VARIABLE CMAKE_INSTALL_FULL_MODULEDIR)
    endif ()
    install(TARGETS Spglib_fortran Spglib_fortran_include
            EXPORT SpglibTargets-fortran
    )
    export_components(
            PROJECT Spglib
            COMPONENT fortran
            LIB_TYPE ${Spglib_LIB_TYPE}
    )
    install(FILES try_compile.f90
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/Spglib
    )
    install(FILES ${CMAKE_Fortran_MODULE_DIRECTORY}/spglib_f08.mod
            DESTINATION ${CMAKE_INSTALL_MODULEDIR}
    )
    configure_file(spglib_f08.pc.in spglib_f08.pc @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/spglib_f08.pc
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    )
endif ()

# Make project available for FetchContent
if (NOT PROJECT_IS_TOP_LEVEL)
    # Propagate variables
    return(PROPAGATE
            Spglib_Fortran_VERSION
            Spglib_Fortran_VERSION_MAJOR
            Spglib_Fortran_VERSION_MINOR
            Spglib_Fortran_VERSION_PATCH
            Spglib_Fortran_VERSION_TWEAK
            Spglib_Fortran_VERSION_FULL
            Spglib_Fortran_COMMIT
            Spglib_LIB_TYPE
    )
endif ()

=== include/CMakeLists.txt ===
target_sources(Spglib_symspg PUBLIC
    FILE_SET HEADERS
    FILES
        spglib.h
)

target_include_directories(Spglib_symspg PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25...3.29)

#[=============================================================================[
#                           Basic project definition                           #
]=============================================================================]

list(APPEND CMAKE_MESSAGE_CONTEXT Python)
project(Spglib_Python
        LANGUAGES C
)

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif ()

#[=============================================================================[
#                                   Options                                   #
]=============================================================================]

option(SPGLIB_INSTALL "Spglib: Install project" ${PROJECT_IS_TOP_LEVEL})
option(SPGLIB_SHARED_LIBS "Spglib: Build as a shared library" ${PROJECT_IS_TOP_LEVEL})

#[=============================================================================[
#                            Project configuration                            #
]=============================================================================]

include(GNUInstallDirs)

set(BUILD_SHARED_LIBS ${SPGLIB_SHARED_LIBS})

#[=============================================================================[
#                                Public targets                                #
]=============================================================================]

# Running `find_package(Python)` early to be able to define target with `Python_add_library`
find_package(Python 3.9 COMPONENTS REQUIRED Interpreter Development.Module NumPy)
Python_add_library(Spglib_python MODULE WITH_SOABI)
add_library(Spglib::python ALIAS Spglib_python)

#[=============================================================================[
#                              External packages                              #
]=============================================================================]

# Get Spglib if it's run as stand-alone project
if (NOT TARGET Spglib::symspg)
    find_package(Spglib CONFIG)
    if (NOT Spglib_FOUND)
        message(STATUS "Using bundled spglib sources")
        add_subdirectory(${PROJECT_SOURCE_DIR}/.. _deps/spglib-build)
    endif ()
endif ()

#[=============================================================================[
#                               Main definition                               #
]=============================================================================]

# Define main target
set_target_properties(Spglib_python PROPERTIES
        OUTPUT_NAME _spglib
        INSTALL_RPATH "$<IF:$<BOOL:${APPLE}>,@loader_path,$ORIGIN>/${CMAKE_INSTALL_LIBDIR}"
)
target_sources(Spglib_python PRIVATE
        _spglib.c
)
target_link_libraries(Spglib_python PRIVATE
        Spglib::symspg Python::NumPy
)
# _version.py may not have been populated in source yet, use a dummy file for the build environment
# TODO: Use a scikit-build-cli or other CLI to populate the metadata files
if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/spglib/_version.py)
    configure_file(_version.py.in spglib/_version.py)
endif ()

# Copy all python packages to the build directory
file(COPY spglib
        DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
# Link the built library to the package in the binary directory
add_custom_command(TARGET Spglib_python POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E create_symlink
        $<TARGET_FILE:Spglib_python>
        ${CMAKE_CURRENT_BINARY_DIR}/spglib/$<TARGET_FILE_NAME:Spglib_python>
)
# On Windows make sure the dll files are in the build directory
# https://stackoverflow.com/a/73550650
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.26)
    # This form works when no files are specified
    add_custom_command(TARGET Spglib_python POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy -t ${CMAKE_CURRENT_BINARY_DIR}/spglib/ $<TARGET_RUNTIME_DLLS:Spglib_python>
            COMMAND_EXPAND_LISTS
    )
else ()
    if(WIN32)
        add_custom_command(TARGET Spglib_python POST_BUILD
                COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_RUNTIME_DLLS:Spglib_python> ${CMAKE_CURRENT_BINARY_DIR}/spglib/
                COMMAND_EXPAND_LISTS
        )
    endif ()
endif ()

#[=============================================================================[
#                              Install or Export                              #
]=============================================================================]

if (NOT SKBUILD AND SPGLIB_INSTALL)
    message(WARNING "Installing the python bindings outside of scikit-build-core environment is not supported.")
elseif (SPGLIB_INSTALL)
    if (TARGET Spglib_symspg)
        # For windows systems we need to also install a copy of the dll files
        install(TARGETS Spglib_symspg
                RUNTIME DESTINATION .
        )
    endif ()
    install(TARGETS Spglib_python
            LIBRARY DESTINATION .
    )
endif ()

=== src/CMakeLists.txt ===
configure_file(version.h.in version.h)
set_property(DIRECTORY APPEND PROPERTY
        CMAKE_CONFIGURE_DEPENDS ${PROJECT_BINARY_DIR}/.git_commit
)
add_dependencies(Spglib_symspg Spglib_GitHash)
target_compile_definitions(Spglib_symspg PRIVATE SPG_BUILD)
# For windows consumers we need to disable __declspec(dllimport) if it's built as a static library
if (WIN32 AND NOT SPGLIB_SHARED_LIBS)
    target_compile_definitions(Spglib_symspg PUBLIC SPG_STATIC_LIBRARY)
endif ()

# Add compiler warnings
if (SPGLIB_COMPILATION_WARNING)
    if (MSVC)
        target_compile_options(Spglib_symspg PRIVATE /W4)
    else ()
        # TODO: C23: Disabled -Wpedantic because of warning spam
        #  Add it back when C23 standard is widespread and revert this [Temp][C23] commit
        target_compile_options(Spglib_symspg PRIVATE -Wall -Wextra)
    endif ()
endif ()

# Configure main target
target_sources(Spglib_symspg PRIVATE
        arithmetic.c
        cell.c
        debug.c
        delaunay.c
        determination.c
        hall_symbol.c
        kgrid.c
        kpoint.c
        magnetic_spacegroup.c
        mathfunc.c
        msg_database.c
        niggli.c
        overlap.c
        pointgroup.c
        primitive.c
        refinement.c
        site_symmetry.c
        sitesym_database.c
        spacegroup.c
        spg_database.c
        spglib.c
        spin.c
        symmetry.c
)
target_include_directories(Spglib_symspg PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
)

# Link to third-party libraries
if (SPGLIB_USE_OMP)
    target_link_libraries(Spglib_symspg PRIVATE OpenMP::OpenMP_C)
endif ()
if (NOT MSVC)
    # Link to mathlibrary
    target_link_libraries(Spglib_symspg PUBLIC m)
endif ()


# Additional settings
if (SPGLIB_DEBUG)
    target_compile_definitions(Spglib_symspg PRIVATE SPGDEBUG)
endif ()
if (SPGLIB_WARNINGS)
    target_compile_definitions(Spglib_symspg PRIVATE SPGWARNING)
endif ()
if (SPGLIB_INFO)
    target_compile_definitions(Spglib_symspg PRIVATE SPGINFO)
endif ()

# Avoid One Definition Rule problems. Please fix these
if (CMAKE_UNITY_BUILD)
    set_source_files_properties(
            symmetry.c site_symmetry.c spacegroup.c spglib.c refinement.c pointgroup.c determination.c delaunay.c
            PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON
    )
endif ()


# Install
if (SPGLIB_INSTALL)
    # Normal installation target to system. When using scikit-build this is installed again in python path
    install(TARGETS Spglib_symspg
        EXPORT SpglibTargets
        FILE_SET HEADERS
    )
endif ()

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25...3.29)

#[=============================================================================[
#                           Basic project definition                           #
]=============================================================================]

list(APPEND CMAKE_MESSAGE_CONTEXT Test)
project(Spglib_Test
        LANGUAGES CXX C
)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)

#[=============================================================================[
#                                   Options                                   #
]=============================================================================]

include(CMakeDependentOption)
include(FeatureSummary)

option(SPGLIB_TEST_COVERAGE "Spglib: Test with coverage" OFF)
set(SPGLIB_USE_SANITIZER "" CACHE STRING "Spglib: Sanitizer used in compilation")
option(SPGLIB_WITH_Fortran "Spglib: Build Fortran interface" OFF)
option(SPGLIB_WITH_Python "Spglib: Build Python interface" OFF)
add_feature_info(Coverage SPGLIB_TEST_COVERAGE "Compile with test coverage")
mark_as_advanced(
        SPGLIB_TEST_COVERAGE
        SPGLIB_USE_SANITIZER
)

#[=============================================================================[
#                            Project configuration                            #
]=============================================================================]

if (SPGLIB_WITH_Fortran)
    enable_language(Fortran)
endif ()
if (SPGLIB_TEST_COVERAGE)
    target_compile_options(Spglib_symspg PRIVATE --coverage)
    target_link_options(Spglib_symspg PUBLIC --coverage)
    if (SPGLIB_WITH_Fortran)
        target_compile_options(Spglib_fortran PRIVATE --coverage)
        target_link_options(Spglib_fortran PUBLIC --coverage)
    endif ()
    if (SPGLIB_WITH_Python)
        target_compile_options(Spglib_python PRIVATE --coverage)
        target_link_options(Spglib_python PUBLIC --coverage)
    endif ()
endif ()
if (SPGLIB_USE_SANITIZER)
    if (CMAKE_CXX_COMPILER_ID MATCHES "(Intel|MSVC)")
        message(WARNING "Sanitizers not supported on: ${CMAKE_CXX_COMPILER_ID}")
    else ()
        string(TOLOWER ${SPGLIB_USE_SANITIZER} SPGLIB_USE_SANITIZER)
        target_compile_options(Spglib_symspg PRIVATE
                -fsanitize=${SPGLIB_USE_SANITIZER}
        )
        target_link_options(Spglib_symspg PUBLIC
                -fsanitize=${SPGLIB_USE_SANITIZER}
        )
    endif ()
endif ()

#[=============================================================================[
#                              External packages                              #
]=============================================================================]

set(external_libs)
include(FetchContent)

# Get Spglib if it's run as stand-alone project
if (NOT TARGET Spglib::symspg)
    set(spglib_find_package_args)
    if (SPGLIB_WITH_Fortran)
        list(APPEND
                COMPONENTS Fortran
        )
    endif ()
    find_package(Spglib REQUIRED CONFIG ${spglib_find_package_args})
endif ()

set(BUILD_GMOCK OFF)
set(INSTALL_GTEST OFF)
set(gtest_disable_pthreads ON)
FetchContent_Declare(GTest
        GIT_REPOSITORY https://github.com/google/googletest
        GIT_TAG v1.15.2
        FIND_PACKAGE_ARGS CONFIG
)

find_package(Threads REQUIRED)
if (SPGLIB_WITH_Python)
    find_package(Python 3.9 REQUIRED)
endif ()

FetchContent_MakeAvailable(GTest)
include(GoogleTest)

#[=============================================================================[
#                               Main definition                               #
]=============================================================================]

enable_testing()

if (WIN32 AND CMAKE_VERSION VERSION_LESS 3.27)
    message(FATAL_ERROR "Cannot reliably test for windows with CMake < 3.27")
endif ()

# Define the test framework
add_executable(Spglib_tests)
set_target_properties(Spglib_tests PROPERTIES
        OUTPUT_NAME test_suite
)
if (SPGLIB_WITH_Fortran)
    add_executable(Spglib_Fortran_tests)
    set_target_properties(Spglib_Fortran_tests PROPERTIES
            OUTPUT_NAME test_suite_fortran
    )
endif ()

# Basic configuration for Spglib_tests
target_sources(Spglib_tests PRIVATE
        utils.c
)
target_link_libraries(Spglib_tests PRIVATE
        Spglib::symspg
        GTest::gtest GTest::gtest_main
        Threads::Threads
)
target_include_directories(Spglib_tests
        PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
)

# Define a helper function to configure the google tests
function(Spglib_add_gtest)
    #[===[.md
    # Spglib_add_gtest

    Internal helper for adding GTest tests with appropriate labels

    ## Synopsis
    ```cmake
    Spglib_add_gtest(TARGET <target> SOURCES <files>
            [LABELS <label1> <label2>])
    ```

    ## Options

    `TARGET`
      GTest target

    `SOURCES`
      Additional sources to add

    `LABELS`
      Additional labels to be added

    ]===]

    list(APPEND CMAKE_MESSAGE_CONTEXT "Spglib_add_gtest")

    set(ARGS_Options)
    set(ARGS_OneValue
            TARGET
    )
    set(ARGS_MultiValue
            LABELS
            SOURCES
    )
    cmake_parse_arguments(PARSE_ARGV 0 ARGS "${ARGS_Options}" "${ARGS_OneValue}" "${ARGS_MultiValue}")

    target_sources(${ARGS_TARGET} PRIVATE ${ARGS_SOURCES})
    gtest_add_tests(TARGET ${ARGS_TARGET}
            SOURCES ${ARGS_SOURCES}
            TEST_LIST google_tests
    )

    # Set test labels
    get_directory_property(test_labels LABELS)
    list(APPEND test_labels ${ARGS_LABELS})
    set_tests_properties(${google_tests} PROPERTIES
            LABELS "${test_labels}"
    )
    if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.27)
        # https://stackoverflow.com/a/77990416
        set_property(TEST ${google_tests} APPEND PROPERTY
                ENVIRONMENT_MODIFICATION "PATH=path_list_prepend:$<JOIN:$<TARGET_RUNTIME_DLL_DIRS:Spglib_tests>,\;>"
        )
    endif ()
endfunction()

function(Spglib_add_test test)
    #[===[.md
    # Spglib_add_test

    Internal helper for adding functional tests specific for Spglib

    ## Synopsis
    ```cmake
    Spglib_add_test(<name>
            [TEST_NAME <test_name>]
            [LABELS <label1> <label2>]
            [TEST_COMMAND <arg1> <arg2>]
            )
    ```

    ## Options

    `<name>`
      Path to the CMake project to be executed relative to `${CMAKE_CURRENT_SOURCE_DIR}`

    `TEST_NAME` [Default: `<name>`]
      Name for the test to be used as the ctest name

    `LABELS`
      Additional labels to be added

    `TEST_COMMAND`
      Test command to use instead of ctest

    ]===]

    list(APPEND CMAKE_MESSAGE_CONTEXT "Spglib_add_test")

    set(ARGS_Options)
    set(ARGS_OneValue
            TEST_NAME
    )
    set(ARGS_MultiValue
            LABELS
            TEST_COMMAND
    )
    cmake_parse_arguments(PARSE_ARGV 1 ARGS "${ARGS_Options}" "${ARGS_OneValue}" "${ARGS_MultiValue}")
    # Check required/optional arguments
    if (ARGC LESS 1)
        message(FATAL_ERROR "Missing test name")
    endif ()
    if (NOT DEFINED ARGS_TEST_NAME)
        set(ARGS_TEST_NAME ${test})
    endif ()
    if (NOT DEFINED ARGS_TEST_COMMAND)
        set(ARGS_TEST_COMMAND
                ${CMAKE_CTEST_COMMAND} --test-dir ${CMAKE_CURRENT_BINARY_DIR}/${test} --output-on-failure
        )
    endif ()

    set(extra_args)
    if (Spglib_IS_TOP_LEVEL)
        list(APPEND extra_args
                -DFETCHCONTENT_TRY_FIND_PACKAGE_MODE=ALWAYS
                # Generated Config file point to binary targets until it is installed
                -DSpglib_ROOT=${Spglib_BINARY_DIR}
                -DFETCHCONTENT_SOURCE_DIR_SPGLIB=${Spglib_SOURCE_DIR}
        )
    endif ()
    list(APPEND extra_args
            -DSPGLIB_WITH_Fortran=${SPGLIB_WITH_Fortran}
    )
    set(compiler_args)
    foreach (lang IN ITEMS C CXX Fortran)
        if (DEFINED CMAKE_${lang}_COMPILER)
            list(APPEND compiler_args -DCMAKE_${lang}_COMPILER=${CMAKE_${lang}_COMPILER})
        endif ()
    endforeach ()

    add_test(NAME ${ARGS_TEST_NAME}
            COMMAND ${CMAKE_CTEST_COMMAND} --build-and-test ${CMAKE_CURRENT_SOURCE_DIR}/${test}
            ${CMAKE_CURRENT_BINARY_DIR}/${test}
            # Use the same build environment as the current runner
            --build-generator "${CMAKE_GENERATOR}"
            --build-options
            ${compiler_args} ${extra_args}
            --test-command ${ARGS_TEST_COMMAND}
    )
    set_tests_properties(${ARGS_TEST_NAME} PROPERTIES
            LABELS "${ARGS_LABELS}"
    )
endfunction()

# Add the individual tests types
add_subdirectory(unit)
add_subdirectory(integration)
add_subdirectory(functional)
add_subdirectory(package)
add_subdirectory(example)

=== test/functional/CMakeLists.txt ===
set_property(DIRECTORY APPEND
        PROPERTY LABELS functional_tests
)

add_subdirectory(c)
if (SPGLIB_WITH_Fortran)
    add_subdirectory(fortran)
endif ()

=== test/integration/CMakeLists.txt ===
set_property(DIRECTORY APPEND
        PROPERTY LABELS integration_tests
)
#Spglib_add_gtest(TARGET Spglib_tests SOURCES
#)

=== test/package/CMakeLists.txt ===
set_property(DIRECTORY APPEND
        PROPERTY LABELS package
)

set(test_list
        FetchContent
        find_package
)
if (NOT Spglib_IS_TOP_LEVEL)
    list(APPEND test_list pkg-config)
endif ()

foreach (test IN LISTS test_list)
    Spglib_add_test(${test} TEST_NAME test-${test})
endforeach ()

=== test/unit/CMakeLists.txt ===
set_property(DIRECTORY APPEND
        PROPERTY LABELS unit_tests
)

Spglib_add_gtest(TARGET Spglib_tests SOURCES
        test_dataset_access.cpp
        test_error.cpp
        test_version.cpp
)
target_compile_definitions(Spglib_tests PRIVATE
        Spglib_VERSION=${Spglib_VERSION}
        Spglib_VERSION_FULL=${Spglib_VERSION_FULL}
        Spglib_COMMIT=${Spglib_COMMIT}
)

if (TARGET Spglib_symspg)
    # Add non-public tests only if test-suite is run by main project
    target_include_directories(Spglib_tests PRIVATE
            ${Spglib_SOURCE_DIR}/src
    )
    target_compile_definitions(Spglib_symspg PRIVATE SPG_TESTING)
    Spglib_add_gtest(TARGET Spglib_tests SOURCES
            test_delaunay.cpp
            test_niggli.cpp
            test_symmetry.cpp
    )
endif ()

=== test/example/c_api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25...3.29)
project(example_spglib LANGUAGES C)

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)

find_package(Spglib REQUIRED)

add_executable(example example.c)
add_executable(example_full example_full.c)

target_link_libraries(example PRIVATE Spglib::symspg)
target_link_libraries(example_full PRIVATE Spglib::symspg)

# Windows is weird like that :/
# https://stackoverflow.com/a/73550650
if (CMAKE_IMPORT_LIBRARY_SUFFIX)
    add_custom_command(TARGET example POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_RUNTIME_DLLS:example> $<TARGET_FILE_DIR:example>
            COMMAND_EXPAND_LISTS
    )
    add_custom_command(TARGET example_full POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_RUNTIME_DLLS:example_full> $<TARGET_FILE_DIR:example_full>
            COMMAND_EXPAND_LISTS
    )
endif ()

=== test/example/fortran_api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25...3.29)
project(example_spglib LANGUAGES Fortran)

find_package(Spglib REQUIRED COMPONENTS fortran)

add_executable(example example.F90)
add_executable(example_full example_full.F90)

target_link_libraries(example PRIVATE Spglib::fortran)
target_link_libraries(example_full PRIVATE Spglib::fortran)

=== debian/changelog ===
spglib (2.6.0-3build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 15:05:43 +0000

spglib (2.6.0-3) unstable; urgency=medium

  * Drop Multi-Arch: same from libspglib-f08-dev (Closes: #1103017)

 -- Andrius Merkys <merkys@debian.org>  Tue, 15 Apr 2025 01:40:09 -0400

spglib (2.6.0-2) unstable; urgency=medium

  * Team upload.
  * d/p/pyproject.toml.patch: Remove license hunk. (Closes: #1102784)

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sat, 12 Apr 2025 16:46:09 -0400

spglib (2.6.0-1) unstable; urgency=medium

  * New upstream version 2.6.0
  * Update debian/copyright.
  * Drop ruby-getspg binary package.
    See https://github.com/spglib/spglib/issues/564 for rationale.

 -- Andrius Merkys <merkys@debian.org>  Fri, 14 Mar 2025 06:34:50 -0400

=== debian/control ===
Source: spglib
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Section: science
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-numpy3,
 gfortran,
 libgtest-dev,
 moreutils,
 pybuild-plugin-pyproject,
 python3-all-dev,
 python3-build,
 python3-numpy,
 python3-pathspec,
 python3-pyproject-metadata,
 python3-pytest <!nocheck>,
 python3-scikit-build-core,
 python3-setuptools,
 python3-setuptools-scm,
 python3-yaml (>= 5),
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/spglib
Vcs-Git: https://salsa.debian.org/science-team/spglib.git
Homepage: https://spglib.github.io/spglib/
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-pybuild

Package: libspglib-f08-2
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C library for crystal symmetry determination (Fortran interface)
 Spglib is a C library for crystal symmetry determination. Symmetry
 operations, space groups and other data can be obtained using this
 symmetry finder.
 .
 Features include:
 .
  * Identify space-group type
  * Find symmetry operations
  * Find a primitive cell
  * Search irreducible k-points
  * Refine crystal structure
  * Wyckoff position assignment
 .
 This package contains Fortran interface.

Package: libspglib-f08-dev
Architecture: any
Section: libdevel
Depends:
 libspglib-f08-2 (= ${binary:Version}),
 ${misc:Depends},
Description: C library for crystal symmetry determination (Fortran development files)
 Spglib is a C library for crystal symmetry determination. Symmetry
 operations, space groups and other data can be obtained using this
 symmetry finder.
 .
 Features include:
 .
  * Identify space-group type
  * Find symmetry operations
  * Find a primitive cell
  * Search irreducible k-points
  * Refine crystal structure
  * Wyckoff position assignment
 .
 This package contains development files for Fortran interface.

Package: libsymspg-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libsymspg2 (= ${binary:Version}),
 ${misc:Depends},
Description: C library for crystal symmetry determination (development files)
 Spglib is a C library for crystal symmetry determination. Symmetry
 operations, space groups and other data can be obtained using this
 symmetry finder.
 .
 Features include:
 .
  * Identify space-group type
  * Find symmetry operations
  * Find a primitive cell
  * Search irreducible k-points
  * Refine crystal structure
  * Wyckoff position assignment
 .
 This package contains static library and header files.

Package: libsymspg2
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C library for crystal symmetry determination
 Spglib is a C library for crystal symmetry determination. Symmetry
 operations, space groups and other data can be obtained using this
 symmetry finder.
 .
 Features include:
 .
  * Identify space-group type
  * Find symmetry operations
  * Find a primitive cell
  * Search irreducible k-points
  * Refine crystal structure
  * Wyckoff position assignment

Package: python3-spglib
Architecture: any
Section: python
Depends:
 python3-numpy,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
XB-Python-Version: ${python3:Versions}
Provides:
 ${python3:Provides},
Description: C library for crystal symmetry determination - Python3 bindings
 Spglib is a C library for crystal symmetry determination. Symmetry
 operations, space groups and other data can be obtained using this
 symmetry finder.
 .
 Features include:
 .
  * Identify space-group type
  * Find symmetry operations
  * Find a primitive cell
  * Search irreducible k-points
  * Refine crystal structure
  * Wyckoff position assignment
 .
 This package contains the Python3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export PYBUILD_NAME = spglib
export PYBUILD_SYSTEM = pyproject
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem cmake --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DSPGLIB_WITH_Fortran=ON

execute_after_dh_auto_build:
	dh_auto_build --buildsystem pybuild -- --after-build 'rm -rf {build_dir}/spglib/lib'

execute_after_dh_auto_test:
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE) dh_auto_test --buildsystem pybuild

execute_after_dh_auto_install:
	dh_auto_install --buildsystem pybuild

execute_after_dh_makeshlibs:
	cut -d - -f 1 debian/libsymspg2/DEBIAN/symbols | sponge debian/libsymspg2/DEBIAN/symbols

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog.md

execute_after_dh_auto_clean:
	dh_auto_clean --buildsystem pybuild
	rm -rf .pytest_cache/ test/functional/python/__pycache__/

=== debian/watch ===
version=4
opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/spglib-$1.tar.gz/" \
   https://github.com/spglib/spglib/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## spglib 2.7.0

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -6,12 +6,12 @@
 
 list(APPEND CMAKE_MESSAGE_CONTEXT Python)
 project(Spglib_Python
-        LANGUAGES C
+        LANGUAGES CXX
 )
 
-set(CMAKE_C_STANDARD 11)
-set(CMAKE_C_STANDARD_REQUIRED ON)
-set(CMAKE_C_EXTENSIONS OFF)
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
 
 if (NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE Release)
@@ -37,8 +37,9 @@
 ]=============================================================================]
 
 # Running `find_package(Python)` early to be able to define target with `Python_add_library`
-find_package(Python 3.9 COMPONENTS REQUIRED Interpreter Development.Module NumPy)
-Python_add_library(Spglib_python MODULE WITH_SOABI)
+find_package(Python 3.9 COMPONENTS REQUIRED Development.Module NumPy)
+find_package(pybind11 CONFIG REQUIRED)
+pybind11_add_module(Spglib_python MODULE WITH_SOABI)
 add_library(Spglib::python ALIAS Spglib_python)
 
 #[=============================================================================[
@@ -61,13 +62,19 @@
 # Define main target
 set_target_properties(Spglib_python PROPERTIES
         OUTPUT_NAME _spglib
+        LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/spglib
+        RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/spglib
         INSTALL_RPATH "$<IF:$<BOOL:${APPLE}>,@loader_path,$ORIGIN>/${CMAKE_INSTALL_LIBDIR}"
 )
 target_sources(Spglib_python PRIVATE
-        _spglib.c
+        _spglib.cpp
+        py_bindings.cpp
 )
 target_link_libraries(Spglib_python PRIVATE
         Spglib::symspg Python::NumPy
+)
+target_include_directories(Spglib_python PRIVATE
+        ${CMAKE_CURRENT_SOURCE_DIR}
 )
 # _version.py may not have been populated in source yet, use a dummy file for the build environment
 # TODO: Use a scikit-build-cli or other CLI to populate the metadata files
@@ -78,12 +85,7 @@
 # Copy all python packages to the build directory
 file(COPY spglib
         DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
-# Link the built library to the package in the binary directory
-add_custom_command(TARGET Spglib_python POST_BUILD
-        COMMAND ${CMAKE_COMMAND} -E create_symlink
-        $<TARGET_FILE:Spglib_python>
-        ${CMAKE_CURRENT_BINARY_DIR}/spglib/$<TARGET_FILE_NAME:Spglib_python>
-)
+
 # On Windows make sure the dll files are in the build directory
 # https://stackoverflow.com/a/73550650
 if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.26)

=== test/functional/fortran/CMakeLists.txt ===
set_property(DIRECTORY APPEND
        PROPERTY LABELS fortran_api
)

# Cannot use native googletest. Using a rudimentary ctest native testing suite
target_sources(Spglib_Fortran_tests PRIVATE
        utils.F90
        c_interface_module.F90
)

# Generated ctest file that switches and displays tests
# Note must be plain C because generated CPP file does not include extern "C"
# TODO: Gather subtests via regex analyzing sources
set(SubTests_test_fortran_spg_get_symmetry
        test_rutile112
        test_zincblende
)
set(SubTests_test_fortran_spg_get_dataset
        test_dataset_rutile112
        test_dataset_zincblende
)
set(SubTests_test_fortran_spg_get_spacegroup_type
        test_spacegroup_type_rutile
        test_spacegroup_type_from_symmetry_Imma
)
set(SubTests_test_fortran_spg_get_magnetic_dataset
        test_rutile_type_III
        test_Cr_type_IV
        test_magnetic_dataset_non_collinear
)
set(SubTests_test_fortran_spg_get_magnetic_spacegroup_type
        test_magnetic_spacegroup_type_Cr
)
set(SubTests_test_fortran_spg_get_symmetry_with_site_tensors
        test_site_tensors_rutile_type_III
        test_site_tensors_Cr_type_IV
        test_site_tensors_non_collinear
)

# Add fortran tests here
create_test_sourcelist(FortranTests_Files
        fortran_test.c
        test_fortran_spg_get_spacegroup_type.F90
        test_fortran_spg_get_dataset.F90
        test_fortran_spg_get_magnetic_spacegroup_type.F90
        test_fortran_spg_get_magnetic_dataset.F90
        test_fortran_spg_get_symmetry_with_site_tensors.F90
        test_fortran_spg_get_symmetry.F90
        test_fortran_spg_refine_cell.F90
        test_fortran_version.F90
)

# CMake < 3.29 includes the driver source in the source list
list(REMOVE_ITEM FortranTests_Files fortran_test.c)
target_sources(Spglib_Fortran_tests PRIVATE
        ${CMAKE_CURRENT_BINARY_DIR}/fortran_test.c
        ${FortranTests_Files}
)
target_link_libraries(Spglib_Fortran_tests PRIVATE Spglib::fortran)
target_link_options(Spglib_Fortran_tests PRIVATE
        "$<$<Fortran_COMPILER_ID:Intel,IntelLLVM>:$<$<COMPILE_LANGUAGE:Fortran>:-nofor-main>>")
target_compile_definitions(Spglib_Fortran_tests PRIVATE
        Spglib_VERSION=${Spglib_VERSION}
        Spglib_VERSION_FULL=${Spglib_VERSION_FULL}
        Spglib_COMMIT=${Spglib_COMMIT}
)

# Loop over all main tests files
foreach (test IN LISTS FortranTests_Files)
    if (test MATCHES ".*fortran_test.*")
        # Skip the test driver
        continue()
    endif ()
    cmake_path(REMOVE_EXTENSION test OUTPUT_VARIABLE test_name)
    # Check if we have subtests defined
    if (DEFINED SubTests_${test_name})
        # Loop over all subtests
        foreach (subtest ${SubTests_${test_name}})
            # Call test via ${Spglib_Fortran_tests} ${test_name} ${subtest}
            # E.g. running manually: ./test_suite_fortran test_fortran_spg_get_symmetry test_rutile112
            add_test(NAME "${test_name}.${subtest}"
                    COMMAND $<TARGET_FILE:Spglib_Fortran_tests> ${test_name} ${subtest}
            )
        endforeach ()
    else ()
        # Only run the main test without arguments. Maybe can pass other variable data though :-?
        add_test(NAME ${test_name}
                COMMAND $<TARGET_FILE:Spglib_Fortran_tests> ${test_name}
        )
    endif ()
endforeach ()

=== debian/changelog ===
spglib (2.7.0-1) unstable; urgency=medium

  * New upstream version 2.7.0

 -- Andrius Merkys <merkys@debian.org>  Fri, 09 Jan 2026 06:11:53 -0500

=== debian/control ===
--- 
+++ 
@@ -12,6 +12,7 @@
  gfortran,
  libgtest-dev,
  moreutils,
+ pybind11-dev,
  pybuild-plugin-pyproject,
  python3-all-dev,
  python3-build,

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 
 include /usr/share/dpkg/pkg-info.mk
+
+export DEB_CXXFLAGS_MAINT_APPEND = -fpermissive
 
 export PYBUILD_NAME = spglib
 export PYBUILD_SYSTEM = pyproject
